//
//  TSChatViewController+View.swift
//  AIEmoji
//
//  Created by 100Years on 2025/2/17.
//

extension TSChatViewController {
    
    
     var creatVipBtn: UIButton{
        let vipBtn = UIButton.createButton(image: UIImage(named: "nav_vip")) { [weak self]  in
            guard let self = self else { return }
            TSPurchaseVC.show(target: self) {
      
            }
        }
        return vipBtn
    }
    
     var creatNavBarView: TSBaseNavContentBarView{
        let navBarView = TSBaseNavContentBarView()
        
        let titleImageView = UIImageView.createImageView(imageName: "nav_title_aichat",contentMode: .scaleToFill)
        navBarView.barView.addSubview(titleImageView)
        titleImageView.snp.makeConstraints { make in
            make.centerY.equalToSuperview()
            make.left.equalTo(16)
        }
        
        let setBtn = UIButton.createButton(image: UIImage(named: "setting")) { [weak self]  in
            guard let self = self else { return }
            let setingVC = TSSetingVC()
            setingVC.hidesBottomBarWhenPushed = true
            navigationController?.pushViewController(setingVC, animated: true)
        }
        navBarView.barView.addSubview(setBtn)
        setBtn.snp.makeConstraints { make in
            make.centerY.equalToSuperview()
            make.trailing.equalTo(-16)
            make.width.height.equalTo(24)
        }
        
        let historyBtn = UIButton.createButton(image: UIImage(named: "aichat_history")) { [weak self]  in
            guard let self = self else { return }
            let historyVC = TSAIChatHistoryVC()
            historyVC.hidesBottomBarWhenPushed = true
            navigationController?.pushViewController(historyVC, animated: true)
        }
        navBarView.barView.addSubview(historyBtn)
        historyBtn.snp.makeConstraints { make in
            make.centerY.equalToSuperview()
            make.trailing.equalTo(-60)
            make.width.height.equalTo(24)
        }
        
        navBarView.barView.addSubview(vipBtn)
        vipBtn.snp.makeConstraints { make in
            make.centerY.equalToSuperview()
            make.trailing.equalTo(-104)
            make.width.height.equalTo(24)
        }
        
        return navBarView
    }
    
    
    var creatInputBarBgView:UIView{
        let inputBarBgView = UIView()
        inputBarBgView.addShadow(shadowColor: "#111111".uiColor.cgColor, shadowOffset: CGSize(width: 0, height: -10), shadowRadius: 10, shadowOpacity: 1.0)
        return inputBarBgView
    }
    
    
    var creatFreeText: UILabel{
        let textLabel = UILabel.createLabel(
            text: "Remaining \(kPurchaseDefault.freeNum(type: .aichat)) free times",
            font: .font(size: 12),
            textColor: "#E83E3E".uiColor,
            textAlignment: .center,
            numberOfLines: 0
        )
        textLabel.isHidden = false
        return textLabel
    }
    
    
    var creatUpgradeVipBg: UIView{
        let upgradeVipBg = UIView()
        
        let imageView = UIImageView.createImageView(imageName: "vip_upgrade_bg",contentMode: .scaleToFill)
        upgradeVipBg.addSubview(imageView)
        imageView.snp.makeConstraints { make in
            make.edges.equalToSuperview()
        }
        
        let label = UILabel.createLabel(
            text:"Free usage limit reached. Upgrade for unlimited chats.".localized,
            font: .font(size: 14,weight: .bold),
            textColor: "#111111".uiColor,
            numberOfLines: 0
        )
        upgradeVipBg.addSubview(label)
        label.snp.makeConstraints { make in
            make.leading.equalTo(16)
            make.top.equalTo(8)
            make.bottom.equalTo(-8)
            make.trailing.equalTo(-95)
        }
        
        let upgradeBtn = UIButton.createButton(
            title: "Upgrade".localized,
            backgroundColor: "#111111".uiColor,
            font:.font(size: 12,weight: .medium),
            titleColor:.white,
            corner: 14) { [weak self]  in
                guard let self = self else { return }
                TSPurchaseVC.show(target: self) { [weak self]  in
//                    guard let self = self else { return }
//                    updateVipView()
                }
            }
        upgradeVipBg.addSubview(upgradeBtn)
        upgradeBtn.snp.makeConstraints { make in
            make.trailing.equalTo(-12)
            make.centerY.equalToSuperview()
            make.width.equalTo(70)
            make.height.equalTo(28)
        }
        return upgradeVipBg
    }
    
    
    var creatScrollToBottomButton: UIButton{
        let backBottomBtn = UIButton.createButton(image: UIImage(named: "down_arrow_line")) { [weak self]  in
            guard let self = self else { return }
            messagesCollectionView.scrollToLastItem(animated: false)
        }
        backBottomBtn.isHidden = true
        backBottomBtn.backgroundColor = .popupColor
        backBottomBtn.cornerRadius = 16.0
        return backBottomBtn
    }
    
    
    
   var creatNavBarContentView: UIView{
        let view = UIView()
        view.backgroundColor = .clear
        return view
    }
    
    var creatNormalNavBarView: TSNormalNavigationBarView{
        let view = TSNormalNavigationBarView()
        return view
    }
    
    
}
